"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var git_server_1 = __importDefault(require("./git-server"));
var gitee_request_1 = __importDefault(require("./gitee-request"));
var Gitee = /** @class */ (function (_super) {
    __extends(Gitee, _super);
    function Gitee() {
        var _this = _super.call(this, 'gitee') || this;
        _this.request = null;
        return _this;
    }
    Gitee.prototype.setToken = function (token) {
        _super.prototype.setToken.call(this, token);
        this.request = new gitee_request_1.default(token);
    };
    Gitee.prototype.getUser = function () {
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.get('/user');
    };
    Gitee.prototype.getOrg = function (username) {
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.get("/users/".concat(username, "/orgs"), {
            page: 1,
            per_page: 100
        });
    };
    Gitee.prototype.getRepo = function (loginName, projectName) {
        var _this = this;
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.get("/repos/".concat(loginName, "/").concat(projectName)).then(function (res) {
            return _this.handleResponse(res);
        });
    };
    Gitee.prototype.createRepo = function (projectName) {
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.post('/user/repos', {
            name: projectName,
        });
    };
    Gitee.prototype.createOrgRepo = function (loginName, projectName) {
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.post("/orgs/".concat(loginName, "/repos"), {
            name: projectName
        });
    };
    Gitee.prototype.getTokenUrl = function () {
        return 'https://gitee.com/personal_access_tokens';
    };
    Gitee.prototype.getTokenHelpUrl = function () {
        return 'https://gitee.com/help/articles/4191';
    };
    Gitee.prototype.getRemote = function (loginName, projectName) {
        return "git@gitee.com:".concat(loginName, "/").concat(projectName, ".git");
    };
    return Gitee;
}(git_server_1.default));
exports.default = Gitee;
//# sourceMappingURL=Gitee.js.map