import { AxiosPromise } from "axios";
import GitServer from "./git-server";
import GithubRequest from "./github-request";
import { GithubUserInfo } from "./interface";
export default class Github extends GitServer {
    request?: GithubRequest;
    constructor();
    setToken(token: string): void;
    getUser(): Promise<import("axios").AxiosResponse<GithubUserInfo, any>> | undefined;
    getOrg(): Promise<import("axios").AxiosResponse<unknown, any>> | undefined;
    getRepo(loginName: string, projectName: string): Promise<import("axios").AxiosResponse<any, any> | null> | undefined;
    createRepo(projectName: string): AxiosPromise<any> | undefined;
    createOrgRepo(loginName: string, projectName: string): AxiosPromise<any> | undefined;
    getTokenUrl(): string;
    getTokenHelpUrl(): string;
    getRemote(loginName: string, projectName: string): string;
}
