"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var cli_log_1 = __importDefault(require("@fujia/cli-log"));
var git_server_1 = __importDefault(require("./git-server"));
var github_request_1 = __importDefault(require("./github-request"));
var Github = /** @class */ (function (_super) {
    __extends(Github, _super);
    function Github() {
        return _super.call(this, "github") || this;
    }
    Github.prototype.setToken = function (token) {
        _super.prototype.setToken.call(this, token);
        this.request = new github_request_1.default(token);
    };
    Github.prototype.getUser = function () {
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.get("/user");
    };
    Github.prototype.getOrg = function () {
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.get("/user/orgs", {
            page: 1,
            per_page: 100,
        });
    };
    Github.prototype.getRepo = function (loginName, projectName) {
        var _this = this;
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.get("/repos/".concat(loginName, "/").concat(projectName)).then(function (res) {
            return _this.handleResponse(res);
        });
    };
    Github.prototype.createRepo = function (projectName) {
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.post("/user/repos", {
            name: projectName,
        }, {
            Accept: "application/vnd.github.v3+json",
        });
    };
    Github.prototype.createOrgRepo = function (loginName, projectName) {
        var _a;
        cli_log_1.default.verbose("[cli-git]", "createOrgRepo:\n      loginName: ".concat(loginName, "\n      projectName: ").concat(projectName, "\n    "));
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.post("/orgs/".concat(loginName, "/repos"), {
            name: projectName,
        }, {
            Accept: "application/vnd.github.v3+json",
        });
    };
    Github.prototype.getTokenUrl = function () {
        return "https://github.com/settings/tokens";
    };
    Github.prototype.getTokenHelpUrl = function () {
        return "https://docs.github.com/en/github/authenticating-to-github/connecting-to-github-with-ssh";
    };
    Github.prototype.getRemote = function (loginName, projectName) {
        return "git@github.com:".concat(loginName, "/").concat(projectName, ".git");
    };
    return Github;
}(git_server_1.default));
exports.default = Github;
//# sourceMappingURL=Github.js.map