"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var simple_git_1 = __importDefault(require("simple-git"));
var fs_extra_1 = __importDefault(require("fs-extra"));
var user_home_1 = __importDefault(require("@fujia/user-home"));
var terminal_link_1 = __importDefault(require("terminal-link"));
var semver_1 = __importDefault(require("semver"));
var cli_log_1 = __importDefault(require("@fujia/cli-log"));
var cli_utils_1 = require("@fujia/cli-utils");
var Github_1 = __importDefault(require("./Github"));
var gitlab_1 = __importDefault(require("./gitlab"));
var Gitee_1 = __importDefault(require("./Gitee"));
var inquire_prompt_1 = require("./inquire-prompt");
var constants_1 = require("./constants");
var GitCore = /** @class */ (function () {
    function GitCore(_a, _b) {
        var projectName = _a.projectName, version = _a.version, sourceDir = _a.sourceDir;
        var _c = _b.refreshRepo, refreshRepo = _c === void 0 ? false : _c, _d = _b.refreshToken, refreshToken = _d === void 0 ? false : _d, _e = _b.refreshOwner, refreshOwner = _e === void 0 ? false : _e;
        this.projectName = projectName; // project name
        this.version = version; // version of project
        this.sourceDir = sourceDir; // directory of source code
        this.git = (0, simple_git_1.default)({
            // instance of SimpleGit
            baseDir: this.sourceDir,
        });
        this.homePath = process.env["STAGE_CLI_HOME" /* STAGE_CLI_HOME */] || ''; // directory of local caches
        this.refreshRepo = refreshRepo; // force to update the remote Git repository
        this.refreshToken = refreshToken; // force to update the token of remote repository
        this.refreshOwner = refreshOwner; // force to update the type of remote repository
        this.remote = ''; // the url of repository, such as: git@github.com:${loginName}/${projectName}.git
        this.token = '';
        this.gitType = 'github';
    }
    GitCore.prototype.prepare = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.checkHomePath()];
                    case 1:
                        _a.sent(); // check the main cached directory
                        return [4 /*yield*/, this.checkGitServer()];
                    case 2:
                        _a.sent(); // check the type of user's remote repository
                        return [4 /*yield*/, this.checkGitToken()];
                    case 3:
                        _a.sent(); // check and obtain the token of remote repository
                        return [4 /*yield*/, this.getUserAndOrgs()];
                    case 4:
                        _a.sent(); // obtain the user of repository and organization information
                        return [4 /*yield*/, this.checkGitOwner()];
                    case 5:
                        _a.sent(); // confirm the type of remote repository
                        return [4 /*yield*/, this.checkRepoAndCreate()];
                    case 6:
                        _a.sent(); // check and create remote repository
                        this.checkGitIgnore(); // check and create the file of .gitignore
                        return [4 /*yield*/, this.init()];
                    case 7:
                        _a.sent(); // initial local repository
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.getRemote())
                            return [2 /*return*/];
                        return [4 /*yield*/, this.initAndAddRemote()];
                    case 1:
                        _a.sent(); // execute "git remote add origin ...
                        return [4 /*yield*/, this.initCommit()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.initAndAddRemote = function () {
        return __awaiter(this, void 0, void 0, function () {
            var remotes;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cli_log_1.default.info('', 'execute git initializing...');
                        return [4 /*yield*/, this.git.init()];
                    case 1:
                        _a.sent();
                        cli_log_1.default.info('', 'execute "git remote add ..."');
                        return [4 /*yield*/, this.git.getRemotes()];
                    case 2:
                        remotes = _a.sent();
                        cli_log_1.default.verbose('[cli-git]', "git remotes: ".concat(remotes.join(', ')));
                        if (!!remotes.find(function (i) { return i.name === 'origin'; })) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.git.addRemote('origin', this.remote)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.initCommit = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.checkConflicted()];
                    case 1:
                        _a.sent(); // check if have code conflicts
                        return [4 /*yield*/, this.checkNotCommitted()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.checkRemoteMain()];
                    case 3:
                        if (!_a.sent()) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.pullRemoteRepo('main', {
                                '--allow-unrelated-histories': null,
                            })];
                    case 4:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 5: return [4 /*yield*/, this.pushRemoteRepo('main')];
                    case 6:
                        _a.sent();
                        _a.label = 7;
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.pullRemoteRepo = function (branchName, options) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cli_log_1.default.info('', "synchronizing remote ".concat(branchName, " branch code"));
                        return [4 /*yield*/, this.git.pull('origin', branchName, options).catch(function (err) {
                                cli_log_1.default.error('', err === null || err === void 0 ? void 0 : err.message);
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.pushRemoteRepo = function (branchName) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cli_log_1.default.info('', "push code to ".concat(branchName, " branch"));
                        return [4 /*yield*/, this.git.push('origin', branchName)];
                    case 1:
                        _a.sent();
                        cli_log_1.default.success('', 'push code successfully');
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.commit = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getCorrectVersion()];
                    case 1:
                        _a.sent(); // generate develop branch
                        return [4 /*yield*/, this.checkStash()];
                    case 2:
                        _a.sent(); // check stash zone
                        return [4 /*yield*/, this.checkConflicted()];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.checkoutBranch(this.branch)];
                    case 4:
                        _a.sent(); // check out develop branch
                        return [4 /*yield*/, this.pullRemoteMainToBranch()];
                    case 5:
                        _a.sent(); // merge remote main branch and develop branch code
                        return [4 /*yield*/, this.pushRemoteRepo(this.branch)];
                    case 6:
                        _a.sent(); // push develop branch to remote repository
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.pullRemoteMainToBranch = function () {
        return __awaiter(this, void 0, void 0, function () {
            var remoteBranchList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cli_log_1.default.info('', "merge [main] branch to [".concat(this.branch, "] branch"));
                        return [4 /*yield*/, this.pullRemoteRepo('main')];
                    case 1:
                        _a.sent();
                        cli_log_1.default.success('', 'merge remote [main] branch code successfully');
                        return [4 /*yield*/, this.checkRemoteMain()];
                    case 2:
                        _a.sent();
                        cli_log_1.default.info('', 'check remote develop branch');
                        return [4 /*yield*/, this.getRemoteBranchList('feature')];
                    case 3:
                        remoteBranchList = _a.sent();
                        if (!remoteBranchList.includes(this.version)) return [3 /*break*/, 6];
                        cli_log_1.default.info('', 'merge remote develop branch to local develop branch');
                        return [4 /*yield*/, this.pullRemoteRepo(this.branch)];
                    case 4:
                        _a.sent();
                        cli_log_1.default.success('', "merge remote [".concat(this.branch, "] branch code successfully"));
                        return [4 /*yield*/, this.checkConflicted()];
                    case 5:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 6:
                        cli_log_1.default.info('', "the remote ".concat(this.branch, " branch is not exist"));
                        _a.label = 7;
                    case 7: return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.checkoutBranch = function (branch) {
        return __awaiter(this, void 0, void 0, function () {
            var localBranchList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!branch)
                            throw new Error("the branch is not exist.");
                        return [4 /*yield*/, this.git.branchLocal()];
                    case 1:
                        localBranchList = _a.sent();
                        if (!localBranchList.all.includes(branch)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.git.checkout(branch)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 3: return [4 /*yield*/, this.git.checkoutLocalBranch(branch)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.checkStash = function () {
        return __awaiter(this, void 0, void 0, function () {
            var stashList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cli_log_1.default.info('', 'check stash records');
                        return [4 /*yield*/, this.git.stashList()];
                    case 1:
                        stashList = _a.sent();
                        if (!(stashList.all.length > 0)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.git.stash(['pop'])];
                    case 2:
                        _a.sent();
                        cli_log_1.default.success('', 'stash pop successfully');
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.getCorrectVersion = function () {
        return __awaiter(this, void 0, void 0, function () {
            var remoteBranchList, releaseVersion, featureVersion, upgradeType, incVersion;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        /**
                         * NOTE: steps
                         *
                         * 1, fetch remote branches
                         * 2, generate local develop branch
                         * 3, synchronizing version to package.json
                         */
                        cli_log_1.default.info('', 'fetch code branches');
                        return [4 /*yield*/, this.getRemoteBranchList(constants_1.VERSION_RELEASE)];
                    case 1:
                        remoteBranchList = _a.sent();
                        if ((remoteBranchList === null || remoteBranchList === void 0 ? void 0 : remoteBranchList.length) > 0) {
                            releaseVersion = remoteBranchList[0];
                        }
                        cli_log_1.default.verbose('[cli-git]', "The latest remote version: ".concat(releaseVersion));
                        featureVersion = this.version;
                        if (!!releaseVersion) return [3 /*break*/, 2];
                        this.branch = "".concat(constants_1.VERSION_FEATURE, "/").concat(featureVersion);
                        return [3 /*break*/, 5];
                    case 2:
                        if (!semver_1.default.gt(this.version, releaseVersion)) return [3 /*break*/, 3];
                        cli_log_1.default.info('', "current version greater than remote latest version:\n        feature: ".concat(featureVersion, "\n        release: ").concat(releaseVersion, "\n      "));
                        this.branch = "".concat(constants_1.VERSION_FEATURE, "/").concat(featureVersion);
                        return [3 /*break*/, 5];
                    case 3:
                        cli_log_1.default.info('', "current version less than remote latest version:\n        feature: ".concat(featureVersion, "\n        release: ").concat(releaseVersion, "\n      "));
                        return [4 /*yield*/, (0, inquire_prompt_1.inquireUpgradeVersionType)(releaseVersion)];
                    case 4:
                        upgradeType = (_a.sent()).upgradeType;
                        incVersion = semver_1.default.inc(releaseVersion, upgradeType);
                        this.branch = "".concat(constants_1.VERSION_FEATURE, "/").concat(incVersion);
                        this.version = incVersion;
                        cli_log_1.default.verbose('[cli-git]', "the branch: ".concat(this.branch));
                        this.syncVersionToPackageJson();
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.getRemoteBranchList = function (type) {
        return __awaiter(this, void 0, void 0, function () {
            var remoteList, versionReg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.git.listRemote(['--refs'])];
                    case 1:
                        remoteList = _a.sent();
                        versionReg = constants_1.VERSION_MAP_REG[type];
                        return [2 /*return*/, remoteList
                                .split('\n')
                                .map(function (remote) {
                                var match = versionReg.exec(remote);
                                versionReg.lastIndex = 0;
                                if (match && semver_1.default.valid(match[1])) {
                                    return match[1];
                                }
                            })
                                .filter(function (_) { return _; })
                                .sort(function (a, b) {
                                if (semver_1.default.lte(b, a)) {
                                    if (a === b)
                                        return 0;
                                    return -1;
                                }
                                return 1;
                            })];
                }
            });
        });
    };
    GitCore.prototype.checkRemoteMain = function () {
        return __awaiter(this, void 0, void 0, function () {
            var remoteList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.git.listRemote(['--refs'])];
                    case 1:
                        remoteList = _a.sent();
                        return [2 /*return*/, (remoteList.indexOf('refs/heads/main') >= 0 || remoteList.indexOf('refs/heads/master') >= 0)];
                }
            });
        });
    };
    GitCore.prototype.checkNotCommitted = function () {
        return __awaiter(this, void 0, void 0, function () {
            var status, not_added, created, deleted, modified, renamed, isNotEmptyStatus, message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.git.status()];
                    case 1:
                        status = _a.sent();
                        not_added = status.not_added, created = status.created, deleted = status.deleted, modified = status.modified, renamed = status.renamed;
                        isNotEmptyStatus = not_added.length > 0 ||
                            created.length > 0 ||
                            deleted.length > 0 ||
                            modified.length > 0 ||
                            renamed.length > 0;
                        if (!isNotEmptyStatus) return [3 /*break*/, 9];
                        return [4 /*yield*/, this.git.add(status.not_added)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.git.add(status.created)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.git.add(status.deleted)];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, this.git.add(status.modified)];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, this.git.add(status.renamed.map(function (f) { return f.to; }))];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, (0, inquire_prompt_1.inquireCommitMessage)()];
                    case 7:
                        message = (_a.sent()).message;
                        if (!message) return [3 /*break*/, 9];
                        return [4 /*yield*/, this.git.commit(message)];
                    case 8:
                        _a.sent();
                        cli_log_1.default.success('', 'commit successfully');
                        _a.label = 9;
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.checkConflicted = function () {
        return __awaiter(this, void 0, void 0, function () {
            var status;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cli_log_1.default.info('', 'check whether have conflicts for code.');
                        return [4 /*yield*/, this.git.status()];
                    case 1:
                        status = _a.sent();
                        if (status.conflicted.length > 0) {
                            throw new Error('There are conflicts in current code. please manually handle the merge and try again.');
                        }
                        cli_log_1.default.success('', 'code conflict check passed.');
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.checkRepoAndCreate = function () {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var res, repo, spinner, result, err_1;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4 /*yield*/, ((_a = this.gitServer) === null || _a === void 0 ? void 0 : _a.getRepo(this.loginName, this.projectName))];
                    case 1:
                        res = _d.sent();
                        repo = res === null || res === void 0 ? void 0 : res.data;
                        if (!!repo) return [3 /*break*/, 9];
                        spinner = (0, cli_utils_1.spinnerInstance)('Starting to create remote repository...');
                        _d.label = 2;
                    case 2:
                        _d.trys.push([2, 6, 7, 8]);
                        if (!(this.owner === constants_1.REPO_OWNER_USER)) return [3 /*break*/, 4];
                        return [4 /*yield*/, ((_b = this.gitServer) === null || _b === void 0 ? void 0 : _b.createRepo(this.projectName))];
                    case 3:
                        result = _d.sent();
                        repo = result === null || result === void 0 ? void 0 : result.data;
                        return [3 /*break*/, 5];
                    case 4:
                        (_c = this.gitServer) === null || _c === void 0 ? void 0 : _c.createOrgRepo(this.loginName, this.projectName);
                        _d.label = 5;
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        err_1 = _d.sent();
                        cli_log_1.default.error('', err_1 === null || err_1 === void 0 ? void 0 : err_1.message);
                        if (process.env["LOG_LEVEL" /* LOG_LEVEL */] === 'verbose') {
                            cli_log_1.default.verbose('[git-core]', err_1);
                        }
                        return [3 /*break*/, 8];
                    case 7:
                        spinner.stop(true);
                        return [7 /*endfinally*/];
                    case 8:
                        if (repo) {
                            cli_log_1.default.success('', 'created the remote repository successfully.');
                        }
                        else {
                            throw new Error('Oops! created the remote repository failed.');
                        }
                        return [3 /*break*/, 10];
                    case 9:
                        cli_log_1.default.success('', 'get the information of remote repository successfully.');
                        _d.label = 10;
                    case 10:
                        cli_log_1.default.verbose('[cli-git]', "the repo: ".concat(repo));
                        this.repo = repo;
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.checkGitServer = function () {
        return __awaiter(this, void 0, void 0, function () {
            var gitServerPath, gitServer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        gitServerPath = this.createPath(constants_1.GIT_SERVER_FILE);
                        gitServer = (0, cli_utils_1.readFile)(gitServerPath);
                        if (!(!gitServer || this.refreshRepo)) return [3 /*break*/, 2];
                        return [4 /*yield*/, (0, inquire_prompt_1.inquireGitPlatform)()];
                    case 1:
                        gitServer = (_a.sent()).gitType;
                        this.gitType = gitServer;
                        (0, cli_utils_1.writeFile)(gitServerPath, gitServer);
                        cli_log_1.default.success('', "write git server success: ".concat(gitServer, " -> ").concat(gitServerPath));
                        return [3 /*break*/, 3];
                    case 2:
                        cli_log_1.default.success('', "get gitServer success: ".concat(gitServerPath));
                        _a.label = 3;
                    case 3:
                        this.gitServer = this.createGitServer(gitServer);
                        if (!this.gitServer) {
                            throw new Error('initial GitServer failed');
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.checkGitToken = function () {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var gitTokenFile, tokenPath, token, tokenUrl;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        gitTokenFile = constants_1.GIT_TOKEN_FILE_MAP[this.gitType];
                        tokenPath = this.createPath(gitTokenFile);
                        token = (0, cli_utils_1.readFile)(tokenPath);
                        if (!(!token || this.refreshToken)) return [3 /*break*/, 2];
                        tokenUrl = (0, terminal_link_1.default)('Personal access tokens', (_a = this.gitServer) === null || _a === void 0 ? void 0 : _a.getTokenUrl());
                        cli_log_1.default.warn('', "\n        The token of ".concat((_b = this.gitServer) === null || _b === void 0 ? void 0 : _b.type, " have not generated, Please make sure that exist.\n        seeing here: ").concat(tokenUrl, "\n      "));
                        console.log();
                        return [4 /*yield*/, (0, inquire_prompt_1.inquireGitToken)()];
                    case 1:
                        token = (_d.sent()).token;
                        (0, cli_utils_1.writeFile)(tokenPath, token);
                        cli_log_1.default.success('', 'write token successfully');
                        return [3 /*break*/, 3];
                    case 2:
                        cli_log_1.default.success('', "get token successfully from ".concat(tokenPath));
                        _d.label = 3;
                    case 3:
                        this.token = token;
                        (_c = this.gitServer) === null || _c === void 0 ? void 0 : _c.setToken(token);
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.getUserAndOrgs = function () {
        var _a, _b, _c, _d, _e;
        return __awaiter(this, void 0, void 0, function () {
            var res, orgRes;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0: return [4 /*yield*/, ((_a = this.gitServer) === null || _a === void 0 ? void 0 : _a.getUser())];
                    case 1:
                        res = _f.sent();
                        this.user = res === null || res === void 0 ? void 0 : res.data;
                        if (!this.user) {
                            throw new Error('fetch user information failed.');
                        }
                        cli_log_1.default.verbose('[cli-git]', "user:\n      login: ".concat((_b = this.user) === null || _b === void 0 ? void 0 : _b.login, "\n    "));
                        return [4 /*yield*/, ((_c = this.gitServer) === null || _c === void 0 ? void 0 : _c.getOrg(this.user.login))];
                    case 2:
                        orgRes = _f.sent();
                        this.orgs = orgRes === null || orgRes === void 0 ? void 0 : orgRes.data;
                        cli_log_1.default.verbose('[cli-git]', "".concat((0, cli_utils_1.spreadObjToString)((_d = this.orgs[0]) === null || _d === void 0 ? void 0 : _d.login, 'orgs')));
                        cli_log_1.default.success('', "".concat((_e = this.gitServer) === null || _e === void 0 ? void 0 : _e.type, ": obtain user and organizations information successfully."));
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.checkGitOwner = function () {
        return __awaiter(this, void 0, void 0, function () {
            var ownerPath, loginPath, owner, login;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        ownerPath = this.createPath(constants_1.GIT_OWN_FILE);
                        loginPath = this.createPath(constants_1.GIT_LOGIN_FILE);
                        owner = (0, cli_utils_1.readFile)(ownerPath);
                        login = (0, cli_utils_1.readFile)(loginPath);
                        if (!(!owner || !login || this.refreshOwner)) return [3 /*break*/, 5];
                        return [4 /*yield*/, (0, inquire_prompt_1.inquireRepoOwner)(this.orgs)];
                    case 1:
                        owner = (_a.sent()).owner;
                        if (!(owner === constants_1.REPO_OWNER_USER)) return [3 /*break*/, 2];
                        login = this.user.login;
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, (0, inquire_prompt_1.inquireOrg)(this.orgs)];
                    case 3:
                        login = (_a.sent()).login;
                        (0, cli_utils_1.writeFile)(ownerPath, owner);
                        (0, cli_utils_1.writeFile)(loginPath, login);
                        cli_log_1.default.success('', "write the ".concat(owner, " in ").concat(ownerPath, " successfully."));
                        cli_log_1.default.success('', "write the ".concat(login, " in ").concat(loginPath, " successfully."));
                        _a.label = 4;
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        cli_log_1.default.success('', "read the ".concat(owner, " successfully."));
                        cli_log_1.default.success('', "read the ".concat(login, " successfully."));
                        _a.label = 6;
                    case 6:
                        this.owner = owner;
                        this.loginName = login;
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.checkHomePath = function () {
        return __awaiter(this, void 0, void 0, function () {
            var homeDir;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!!this.homePath) return [3 /*break*/, 2];
                        return [4 /*yield*/, (0, user_home_1.default)()];
                    case 1:
                        homeDir = _a.sent();
                        this.homePath = path_1.default.resolve(homeDir, constants_1.DEFAULT_CLI_HOME);
                        _a.label = 2;
                    case 2:
                        cli_log_1.default.verbose('[cli-git]', "homePath: ".concat(this.homePath));
                        fs_extra_1.default.ensureDirSync(this.homePath);
                        if (!fs_1.default.existsSync(this.homePath)) {
                            throw new Error('Oops! Gets user home directory failed.');
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    GitCore.prototype.syncVersionToPackageJson = function () {
        var pkg = fs_extra_1.default.readJSONSync("".concat(this.sourceDir, "/package.json"));
        if (pkg && pkg.version !== this.version) {
            pkg.version = this.version;
            fs_extra_1.default.writeJsonSync("".concat(this.sourceDir, "/package.json"), pkg, { spaces: 2 });
        }
    };
    GitCore.prototype.getRemote = function () {
        var gitPath = path_1.default.resolve(this.sourceDir, constants_1.GIT_ROOT_DIR);
        if (this.gitServer) {
            this.remote = this.gitServer.getRemote(this.loginName, this.projectName);
        }
        if (fs_1.default.existsSync(gitPath)) {
            cli_log_1.default.success('', 'Git finished initialization');
            return true;
        }
    };
    GitCore.prototype.checkGitIgnore = function () {
        var gitIgnore = path_1.default.resolve(this.sourceDir, constants_1.GIT_IGNORE_FILE);
        if (!fs_1.default.existsSync(gitIgnore)) {
            (0, cli_utils_1.writeFile)(gitIgnore, constants_1.IGNORE_FILE_CONTENT);
            cli_log_1.default.success('', "write the git ignore content in ".concat(gitIgnore, " successfully."));
        }
    };
    GitCore.prototype.createGitServer = function (gitType) {
        if (gitType === 'github') {
            return new Github_1.default();
        }
        else if (gitType === 'gitee') {
            return new Gitee_1.default();
        }
        else if (gitType === 'gitlab') {
            return new gitlab_1.default();
        }
    };
    GitCore.prototype.createPath = function (file) {
        var gitRootDir = path_1.default.resolve(this.homePath, constants_1.GIT_ROOT_DIR);
        var filePath = path_1.default.resolve(gitRootDir, file);
        fs_extra_1.default.ensureDirSync(gitRootDir);
        return filePath;
    };
    return GitCore;
}());
exports.default = GitCore;
//# sourceMappingURL=git-core.js.map