"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var constants_1 = require("./constants");
var GiteeRequest = /** @class */ (function () {
    function GiteeRequest(token) {
        this.token = token;
        this.token = token;
        this.service = axios_1.default.create({
            baseURL: constants_1.GITEE_BASE_URL,
            timeout: 5000,
        });
        this.service.interceptors.response.use(function (response) {
            return response;
        }, function (error) {
            if (error.response && error.response.data) {
                return error.response;
            }
            else {
                return Promise.reject(error);
            }
        });
    }
    GiteeRequest.prototype.get = function (url, params, headers) {
        if (params === void 0) { params = {}; }
        return this.service({
            url: url,
            params: __assign(__assign({}, params), { access_token: this.token }),
            method: 'get',
            headers: headers
        });
    };
    GiteeRequest.prototype.post = function (url, data, headers) {
        return this.service({
            url: url,
            params: {
                access_token: this.token
            },
            data: data,
            method: 'post',
            headers: headers
        });
    };
    return GiteeRequest;
}());
exports.default = GiteeRequest;
//# sourceMappingURL=gitee-request.js.map