"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var constants_1 = require("./constants");
var GitlabRequest = /** @class */ (function () {
    function GitlabRequest(token) {
        var _this = this;
        this.token = token;
        this.token = token;
        this.service = axios_1.default.create({
            baseURL: constants_1.GITLAB_BASE_URL,
            timeout: 5000
        });
        this.service.interceptors.request.use(function (config) {
            config.headers = __assign(__assign({}, (config.headers || {})), { Authorization: "token ".concat(_this.token) });
            return config;
        }, function (error) {
            Promise.reject(error);
        });
        this.service.interceptors.response.use(function (response) { return response; }, function (error) {
            var _a;
            if ((_a = error === null || error === void 0 ? void 0 : error.response) === null || _a === void 0 ? void 0 : _a.data) {
                return error.response;
            }
            return Promise.reject(error);
        });
    }
    GitlabRequest.prototype.get = function (url, params, headers) {
        if (params === void 0) { params = {}; }
        return this.service({
            url: url,
            params: params,
            method: 'get',
            headers: headers
        });
    };
    GitlabRequest.prototype.post = function (url, data, headers) {
        return this.service({
            url: url,
            data: data,
            method: 'post',
            headers: headers
        });
    };
    return GitlabRequest;
}());
exports.default = GitlabRequest;
//# sourceMappingURL=gitlab-request.js.map