"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var git_server_1 = __importDefault(require("./git-server"));
var gitlab_request_1 = __importDefault(require("./gitlab-request"));
var Gitlab = /** @class */ (function (_super) {
    __extends(Gitlab, _super);
    function Gitlab() {
        return _super.call(this, "gitlab") || this;
    }
    Gitlab.prototype.setToken = function (token) {
        _super.prototype.setToken.call(this, token);
        this.request = new gitlab_request_1.default(token);
    };
    Gitlab.prototype.getUser = function () {
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.get("/user");
    };
    Gitlab.prototype.getOrg = function () {
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.get("/user/orgs", {
            page: 1,
            per_page: 100,
        });
    };
    Gitlab.prototype.getRepo = function (loginName, projectName) {
        var _this = this;
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.get("/repos/".concat(loginName, "/").concat(projectName)).then(function (res) {
            return _this.handleResponse(res);
        });
    };
    Gitlab.prototype.createRepo = function (projectName) {
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.post("/user/repos", {
            name: projectName,
        }, {
            Accept: "application/vnd.github.v3+json",
        });
    };
    Gitlab.prototype.createOrgRepo = function (loginName, projectName) {
        var _a;
        return (_a = this.request) === null || _a === void 0 ? void 0 : _a.post("/orgs/".concat(loginName, "/repos"), {
            name: projectName,
        }, {
            Accept: "application/vnd.github.v3+json",
        });
    };
    Gitlab.prototype.getTokenUrl = function () {
        return "";
    };
    Gitlab.prototype.getTokenHelpUrl = function () {
        return "";
    };
    Gitlab.prototype.getRemote = function (loginName, projectName) {
        return "git@gitlab.com:".concat(loginName, "/").concat(projectName, ".git");
    };
    return Gitlab;
}(git_server_1.default));
exports.default = Gitlab;
//# sourceMappingURL=gitlab.js.map