"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.inquireUpgradeVersionType = exports.inquireCommitMessage = exports.inquireOrg = exports.inquireRepoOwner = exports.inquireGitToken = exports.inquireGitPlatform = void 0;
var inquirer_1 = __importDefault(require("inquirer"));
var terminal_link_1 = __importDefault(require("terminal-link"));
var semver_1 = __importDefault(require("semver"));
var helper_1 = require("./helper");
var constants_1 = require("./constants");
var inquireGitPlatform = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, inquirer_1.default.prompt({
                    type: 'list',
                    name: 'gitType',
                    message: 'please select the git platform:',
                    default: constants_1.GITHUB,
                    choices: constants_1.INQUIRE_GIT_PLATFORMS,
                })];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.inquireGitPlatform = inquireGitPlatform;
var inquireGitToken = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, inquirer_1.default.prompt({
                    type: 'password',
                    name: 'token',
                    message: 'please copy your token to here:',
                    default: '',
                })];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.inquireGitToken = inquireGitToken;
var inquireRepoOwner = function (orgs) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, inquirer_1.default.prompt({
                    type: 'list',
                    name: 'owner',
                    message: 'please select remote repository type:',
                    default: constants_1.REPO_OWNER_USER,
                    choices: (orgs === null || orgs === void 0 ? void 0 : orgs.length) > 0 ? constants_1.GIT_OWNER_TYPE : constants_1.GIT_OWNER_TYPE_ONLY
                })];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.inquireRepoOwner = inquireRepoOwner;
var inquireOrg = function (orgs) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, inquirer_1.default.prompt({
                    type: 'list',
                    name: 'login',
                    message: 'please select the organization',
                    choices: orgs.map(function (org) { return ({
                        name: org.login,
                        value: org.login,
                    }); }),
                })];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.inquireOrg = inquireOrg;
var commitLintLink = (0, terminal_link_1.default)('@commitlint/config-conventional', 'https://www.npmjs.com/package/@commitlint/config-conventional');
var inquireCommitMessage = function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, inquirer_1.default.prompt([{
                        type: 'input',
                        name: 'message',
                        message: 'please input commit message',
                        default: '',
                        validate: function (msg) {
                            var done = this.async();
                            setTimeout(function () {
                                if (!(0, helper_1.isValidCommitMsg)(msg)) {
                                    done("this message is invalid, please consults here: ".concat(commitLintLink, " and re-enter"));
                                    return false;
                                }
                                done(null, true);
                            }, 300);
                        }
                    }])];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.inquireCommitMessage = inquireCommitMessage;
var inquireUpgradeVersionType = function (releaseVersion) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, inquirer_1.default.prompt({
                    type: 'list',
                    name: 'upgradeType',
                    message: 'please select the upgrade type for version',
                    default: 'patch',
                    choices: [
                        {
                            name: "patch(".concat(releaseVersion, " -> ").concat(semver_1.default.inc(releaseVersion, 'patch'), ")"),
                            value: 'patch'
                        },
                        {
                            name: "minor(".concat(releaseVersion, " -> ").concat(semver_1.default.inc(releaseVersion, 'minor'), ")"),
                            value: 'minor'
                        },
                        {
                            name: "major(".concat(releaseVersion, " -> ").concat(semver_1.default.inc(releaseVersion, 'major'), ")"),
                            value: 'major'
                        },
                    ]
                })];
            case 1: return [2 /*return*/, _a.sent()];
        }
    });
}); };
exports.inquireUpgradeVersionType = inquireUpgradeVersionType;
//# sourceMappingURL=inquire-prompt.js.map