import Gitee from "./Gitee";
import Github from "./Github";
import Gitlab from "./gitlab";
export declare type GitPlatformType = 'github' | 'gitlab' | 'gitee';
export declare type GitServer<T> = T extends 'github' ? Github : T extends 'gitlab' ? Gitlab : Gitee;
export declare type BranchType = 'release' | 'feature' | 'develop';
export declare type UpgradeVersionType = 'major' | 'minor' | 'patch';
export interface GithubUserInfo {
    id: string;
    login: string;
    node_id: string;
    avatar_url: string;
    gravatar_id?: string;
    url: string;
    html_url: string;
    followers_url: string;
    following_url: string;
    gists_url: string;
    starred_url: string;
    subscriptions_url: string;
    organizations_url: string;
    repos_url: string;
    events_url: string;
    received_events_url: string;
    type: string;
    site_admin: string;
    name: string;
    company?: string;
    blog: string;
    location?: string;
    email: string;
    hireable?: string;
    bio?: string;
    twitter_username?: string;
    public_repos: string;
    public_gists: string;
    followers: string;
    following: string;
    created_at: Date;
    updated_at: Date;
}
export interface GithubOrgInfo {
    login: string;
    id: string;
    node_id: string;
    url: string;
    repos_url: string;
    events_url: string;
    hooks_url: string;
    issues_url: string;
    members_url: string;
    public_members_url: string;
    avatar_url: string;
    description: string;
}
